#include "mainwindow.h"
#include "ui_mainwindow.h"

#include "c.h"
#include <QTreeWidgetItem>

MainWindow::MainWindow(QWidget *parent) :
    QMainWindow(parent),
    ui(new Ui::MainWindow)
{
    ui->setupUi(this);
    test ();
}

MainWindow::~MainWindow()
{
    delete ui;
}

#define SHOW(x) \
{ \
QTreeWidgetItem * item = new QTreeWidgetItem; \
int n = (char *) & v.x - (char *) & v; \
QString s = QString (#x) + " size " + QString::number (sizeof (v.x)) + \
            ", offset " + QString::number (n); \
item->setText (0, s); \
top->addChild (item); \
}

#define SIMPLE(x) \
{ \
QTreeWidgetItem * item = new QTreeWidgetItem; \
int n = 2*(x); \
QString s = "simple " + QString::number (n); \
item->setText (0, s); \
top->addChild (item); \
}

void MainWindow::test ()
{
    QTreeWidgetItem * t = new QTreeWidgetItem ();
    t->setText (0, "C pointer size " + QString::number (sizeof (C*)));
    ui->treeWidget->addTopLevelItem (t);

    {
       QTreeWidgetItem * top = new QTreeWidgetItem ();
       top->setText (0, "C size " + QString::number (sizeof (C)));
       ui->treeWidget->addTopLevelItem (top);

       C v;

       SHOW (x)
       SHOW (y)
       SHOW (z)
    }

    {
       QTreeWidgetItem * top = new QTreeWidgetItem ();
       top->setText (0, "D size " + QString::number (sizeof (D)));
       ui->treeWidget->addTopLevelItem (top);

       D v;

       SHOW (x)
       SHOW (y)
       SHOW (z)
       SHOW (a)
       SHOW (b)
       SHOW (c)
       SHOW (w)
    }


    {
    D * d = new D ();
    C * c = d;
    int p = (char *) c - (char *) d;

    QTreeWidgetItem * u = new QTreeWidgetItem ();
    u->setText (0, "C position in D is " + QString::number (p));
    ui->treeWidget->addTopLevelItem (u);
    }

    {
    D * d = new D ();
    A * a = d;
    int p = (char *) a - (char *) d;

    QTreeWidgetItem * u = new QTreeWidgetItem ();
    u->setText (0, "A position in D is " + QString::number (p));
    ui->treeWidget->addTopLevelItem (u);
    }

}
